/********************************
Author: Chaplin
E-mail: chaplin_hack@hotmail.com
********************************/
import java.awt.*;
//import java.awt.event.*;
import javax.swing.*;
//import java.util.*;

public class StrangeApplet extends JApplet
{
	public static boolean doTick = true;
		
	
	/**
	 * Entry point of the program
	 * @param args An array of command lines.
	 */
	public void init()
	{
		boolean noX = false;
		StrangeView view = null;
		StrangeController controller = null;
        int delay = 2;
		
		MathAccel.init();
		StrangeWorld world = new StrangeWorld(500, 500);

		StrangeGeneCollection geneCol;
		for (int i = 0; i < 30; ++i)
		{
			geneCol = new StrangeGeneCollection();
			geneCol.setNNGene(new StrangeNNGene());
			world.addCreature(new StrangePredator(geneCol));
		}
			
		for (int i = 0; i < 30; ++i)
		{
			geneCol = new StrangeGeneCollection();
			geneCol.setNNGene(new StrangeNNGene());
			world.addCreature(new StrangePrey(geneCol));
		}
		
		if (!noX)
		{
			view = new StrangeView();
			controller = new StrangeController(world, view);
		
			getContentPane().setLayout(new GridLayout(1, 1, 0, 0));

			getContentPane().add(view);
		
			view.setBounds(0, 0, 500, 500);
			setVisible(true);
		
			view.createBufferImage();
			controller.doRendering = true;
		}
		int ntick = 0;
		int gcClock = 0;
		while (doTick)
		{
			if (!controller.isPaused)
			{
				world.tick();
				if (!noX && controller != null)
				if (controller.doRendering)
				{
					try
					{
						Thread.currentThread().sleep(delay);
					}
					catch(InterruptedException e) {}
				}
				if (++gcClock > 250)
				{
					gcClock = 0;
					System.gc();
				}
			}
		}
		
//		System.exit(0);
	}
	
}
